--***Rolling Thunder 1967 Version 3.0
--********* DATA ENTRY SECTION *********--

--***Name Sides
PlayerSideName = "USAF"
OPFORsideName = "VPAF" 

--***Flight Names
playerCallsign = {}
playerCallsign[1] = 'Knight'
playerCallsign[2] = 'Rook'
playerCallsign[3] = 'Bishop'
playerCallsign[4] = 'King'
playerCallsign[5] = 'Queen'
playerCallsign[6] = 'Pawn'

playerEscortCallsign = {} 
playerEscortCallsign[1] = 'Olds'
playerEscortCallsign[2] = 'Pontiac'
playerEscortCallsign[3] = 'Ford'
playerEscortCallsign[4] = 'Chevy'

playerSupportCallsign = {}
playerSupportCallsign[1] = 'Barracuda'
playerSupportCallsign[2] = 'Trout'
playerSupportCallsign[3] = 'Spark'

playerStandoffCallsign = {}
playerStandoffCallsign[1] = 'Volt'
playerStandoffCallsign[2] = 'Exxon'

playerReconCallsign = 'Eagle'
playerReconCallsignSpecial1 = 'Dragon'
playerReconCallsignSpecial2 = 'Misty'
playerReconCallsignSpecial3 = 'Snoopy'

enemyCallsign = 'Red'
enemyTargetCallsign = 'Grunt'

--***Define Airfields
PlayerAirfield1= {name="Udorn RTAFB", latitude='N 17.23.11',  longitude='E 102.47.18',  heading= 297.0}
PlayerAirfield2= {name="Ubon RTAFB",  latitude='N 15.15.05' , longitude='E 104.52.13',  heading= 230.0}
PlayerAirfield3= {name="Da Nang AB",  latitude='N 16.02.38' , longitude='E 108.11.58',  heading= 350.0}

OPFORAirfield1= {name="Phuc Yen AB",  latitude='N 21.13.16',  longitude='E 105.48.26',  heading= 290.0}
OPFORAirfield2= {name="Kep AB",      latitude='N 21.23.23',   longitude='E 106.15.09',  heading= 250.0 }
OPFORAirfield3= {name="Hoa Lac AB",  latitude='N 21.02.17',   longitude='E 105.29.24',  heading= 90.0 }

--***Define OPFOR Radars (Tall King 1802, Bar Lock 1801, Knife Rest 1809, Spoon Rest 1800)
GciRadar1= {name = 'GCI Radar 1', latitude = 21.6858379435911, longitude = 104.141244806841, dbid = 1802}  
GciRadar2= {name = 'GCI Radar 2', latitude = 18.631474, longitude = 105.734614, dbid = 1801} 	
GciRadar3= {name = 'GCI Radar 3', latitude = 'N 21.13.10', longitude = 'E 105.48.26', dbid = 1801} 
GciRadar4= {name = 'GCI Radar 4', latitude = 'N 21.19.07', longitude = 'E 105.29.26', dbid = 1800}  
GciRadar5= {name = 'GCI Radar 5', latitude = 'N 17.15.50', longitude = 'E 106.42.40', dbid = 1800} 	
GciRadar6= {name = 'GCI Radar 6', latitude = 'N 19.45.10', longitude = 'E 105.48.29', dbid = 1809}

--***Time, messages, etc.
ScenarioTime = {Date="9.15.1967", Time="06.30.00"}
ScenarioMessage1 = "Destroy your assigned targets. Beware of hostile AAA, SAMs, and MiGs. Return your aircraft to their home airfield upon mission completion."	


--***Special
shrikeLoadout = 7793
F105Ddbid = 3921
cbuLoadout = 9490 

supportOption1 = "7793"
supportOption2 = "9490"
supportOption3 = "9943" 

standoffOption1 = "10071" 
standoffOption2 = "1289"

RF101CDbid = "3934"
RF4CDbid = "4057"
RF4BDbid = "4055"
RB66BDbid = "345"
F100FDbid = "2745"
U2CDbid = "1888" 
O2ADbid = "3999"
--***************************--
	
--********* FUNCTION DEFINITIONS *********--
function ReturnClassAndLoadout(targetString,delimiter)
	local delimiter = string.find(targetString,delimiter)
	local extractedClass = string.sub(targetString,1,delimiter-1)
	local extractedLoadout = string.sub(targetString,delimiter+1,string.len(targetString))
	return {dbid = extractedClass,loadout = extractedLoadout}
end

function AddMultipleAircraft(quantity,callsign,side,dbid,loadout,latitude,longitude,heading,altitude,proficiency,groupName)
	local circle = World_GetCircleFromPoint({latitude=latitude,longitude=longitude,radius=0.5,numpoints = 72})
	local addedAircraftTable = {}
	if heading == nil then heading = 0 end
	if altitude== nil then altitude = 10000.0 end
	if quantity < 1 then quantity = 0 end
		for i = 1, quantity do
			if i > 1 then
				position = circle[i-1]
			else
				position = {latitude=latitude,longitude=longitude}
			end
			local unit = ScenEdit_AddUnit({type='Aircraft',side=side,dbid=dbid,name=callsign..' #'..i,loadoutid=loadout,latitude=position.latitude,longitude=position.longitude,heading=heading,altitude=altitude,proficiency=proficiency}); --default alt of 36kft; undefined altitude will throw an error; also seems to only recognise the integer and not the decimal so the underlying function may need tweaking
			unit.group=groupName
			table.insert(addedAircraftTable,unit)
		end	
	return addedAircraftTable
end

function AddFingerFour(callsign,side,dbid,loadout,latitudeIn,longitudeIn,heading,altitude,proficiency,groupName)
	--local circle = World_GetCircleFromPoint({latitude=latitude,longitude=longitude,radius=0.5,numpoints = 72})
	local addedAircraftTable = {}
	if heading == nil then heading = 0 end
	if altitude== nil then altitude = 10000.0 end
	--if quantity < 1 then quantity = 0 end
		for i = 1, 4 do
			if i == 1 then
				position = {latitude=latitudeIn,longitude=longitudeIn}
			elseif i == 2 then 
				position = {latitude=latitudeIn-0.002,longitude=longitudeIn-0.002}
			elseif i == 3 then
				position = {latitude=latitudeIn-0.002,longitude=longitudeIn+0.002}
			elseif i == 4 then	
				position = {latitude=latitudeIn-0.004,longitude=longitudeIn+0.004}
			else
				position = {latitude=latitudeIn,longitude=longitudeIn}
			end
			
			local unit = ScenEdit_AddUnit({type='Aircraft',side=side,dbid=dbid,name=callsign..' #'..i,loadoutid=loadout,latitude=position.latitude,longitude=position.longitude,heading=heading,altitude=altitude,proficiency=proficiency}); --default alt of 36kft; undefined altitude will throw an error; also seems to only recognise the integer and not the decimal so the underlying function may need tweaking
			unit.group=groupName
			table.insert(addedAircraftTable,unit)
		end	
	return addedAircraftTable
end

function AddGroundUnits(quantity, callsign, dbid, latitude, longitude, divisorMod, isAutoDetected)
	--lat-lon is lower left corner of closest unit. Divisor will dictate how close, 1 will be ~ 35 mile. 2 will be 17 miles, 4 will be 7 miles. .5 will be 65 miles. .25 will be 90 miles
	--math.randomseed(os.time())
	latbasic = latitude
	lonbasic = longitude
	divisor = divisorMod --divisor changes spacing
	for i = 1,quantity do
		redo_count = 0
		::redo::
		local lat_var = (math.random(1,(10^14))/divisor)
		print(lat_var)
		local lon_var = (math.random(1,(10^14))/divisor)
		print(lon_var)
		DummyPoint=ScenEdit_AddReferencePoint({side=OPFORsideName, name="DummyPoint", latitude=latbasic, longitude=lonbasic, highlighted=false}) --This is for a compatibility fix for using Sting DMS format for Lat/Lon  
		v_lat = DummyPoint.latitude + (lat_var/(10^14)) 
		print("V.Lat is ".. v_lat)
		v_lon = DummyPoint.longitude + (lon_var/(10^14)) 
		print("V.Lon is ".. v_lon)
		ScenEdit_DeleteReferencePoint({side=OPFORsideName, name="DummyPoint"})
		elevation = World_GetElevation({latitude=v_lat, longitude=v_lon})
		if elevation < 1.0 then --Checks to see if the water is deep enough, adjust as you please
			redo_count = redo_count + 1
			if redo_count > 50 then
				if DebugMode == 1 then
					ScenEdit_AddReferencePoint({side=PlayerSideName, name="Unit "..callsign..i.." underwater 50x", lat=v_lat, lon=v_lon, highlighted=true})
					ScenEdit_AddReferencePoint({side=OPFORsideName, name="Unit "..callsign..i.." underwater 50x", lat=v_lat, lon=v_lon, highlighted=true})
				end
				break --this cuts the loop if there are no suitable positions found after 50 tries, prevents infinite loop/game freeze
			else
				goto redo --retries the placement if the water is too shallow
			end
		end
	DBIDUnit = dbid
	local new_merch = ScenEdit_AddUnit({side=OPFORsideName, type='Facility',name=callsign ..i, dbid=DBIDUnit, latitude=v_lat, longitude=v_lon, autodetectable=isAutoDetected})
	if DebugMode == 1 then
		ScenEdit_AddReferencePoint({side=PlayerSideName, name="Unit "..callsign..i.." created", lat=v_lat, lon=v_lon, highlighted=true})
	end	
	--ScenEdit_SetEMCON('Unit', new_merch.guid, 'Inherit;'..EnemyEMCON)
	end

end

--***************************--	


--********* SCENARIO SETUP *********--

--***Side definitions

if DebugModeOPFOR == 1 then --play as OPFOR for debugging
	ScenEdit_AddSide({Name=OPFORsideName})
	ScenEdit_AddSide({Name=PlayerSideName})
else	--normal play
	ScenEdit_AddSide({Name=PlayerSideName})
	ScenEdit_AddSide({Name=OPFORsideName})
end

ScenEdit_SetSidePosture(PlayerSideName, OPFORsideName, "H")
ScenEdit_SetSidePosture(OPFORsideName, PlayerSideName, "H")

--***Convert altitudes to feet
StartAltitude = StartAltitude.." FT"
EnemyAltitude = EnemyAltitude.." FT"


--***Set a flag to determine if enemy SAMS and radar are autodetected
if EnemySAMdetect == 0 then
	enemySAMdetectBool = false	
elseif EnemySAMdetect == 1 then 	
	enemySAMdetectBool = true
else	
	enemySAMdetectBool = true
	ScenEdit_AddReferencePoint({side=PlayerSideName, name="Error with SAM visibility settings!", lat=17.417, lon=106.432, highlighted=true})
end

--***Set a flag to determine if enemy targets are autodetected
if EnemyTargetDetect == 0 then
	enemyTargetDetectBool = false	
elseif EnemyTargetDetect == 1 then 	
	enemyTargetDetectBool = true
else	
	enemyTargetDetectBool = true
	ScenEdit_AddReferencePoint({side=PlayerSideName, name="Error with Target visibility settings!", lat=17.417, lon=106.432, highlighted=true})
end

--***Enemy ROE is WEAPONS_FREE, Player ROE is WEAPONS_TIGHT (a historical frustration!)  
ScenEdit_SetDoctrine({side=OPFORsideName},{weapon_control_status_air=0})
ScenEdit_SetDoctrine({side=PlayerSideName},{weapon_control_status_air=1})

--***USAF needs to look for MiGs and start standoff jamming from the start  
ScenEdit_SetEMCON('Side',PlayerSideName,'Radar=Active;Sonar=Passive;OECM=Active')
--ScenEdit_SetEMCON('Side',OPFORsideName,'Radar=Active;Sonar=Passive;OECM=Passive')

--***Set time and play starting messages, etc.
ScenEdit_SetTime(ScenarioTime)
ScenEdit_SpecialMessage (PlayerSideName, ScenarioMessage1)

--***Add all static, non-random units

--***Airfields
PlayerAirfield1=ScenEdit_AddUnit({side=PlayerSideName, type='Facility', name=PlayerAirfield1.name, dbid=1568, latitude=PlayerAirfield1.latitude, longitude=PlayerAirfield1.longitude, heading=PlayerAirfield1.heading})
PlayerAirfield2=ScenEdit_AddUnit({side=PlayerSideName, type='Facility', name=PlayerAirfield2.name, dbid=1568, latitude=PlayerAirfield2.latitude, longitude=PlayerAirfield2.longitude, heading=PlayerAirfield2.heading})
PlayerAirfield3=ScenEdit_AddUnit({side=PlayerSideName, type='Facility', name=PlayerAirfield3.name, dbid=1568, latitude=PlayerAirfield3.latitude, longitude=PlayerAirfield3.longitude, heading=PlayerAirfield3.heading})

ScenEdit_AddUnit({side=OPFORsideName, type='Facility', name=OPFORAirfield1.name, dbid=1568, latitude=OPFORAirfield1.latitude, longitude=OPFORAirfield1.longitude, heading=OPFORAirfield1.heading})
ScenEdit_AddUnit({side=OPFORsideName, type='Facility', name=OPFORAirfield2.name, dbid=1568, latitude=OPFORAirfield2.latitude, longitude=OPFORAirfield2.longitude, heading=OPFORAirfield2.heading})
ScenEdit_AddUnit({side=OPFORsideName, type='Facility', name=OPFORAirfield3.name, dbid=1568, latitude=OPFORAirfield3.latitude, longitude=OPFORAirfield3.longitude, heading=OPFORAirfield3.heading})

--***Radar 
ScenEdit_AddUnit({type='Facility', side=OPFORsideName, dbid=GciRadar1.dbid, unitname=GciRadar1.name, latitude=GciRadar1.latitude, longitude=GciRadar1.longitude, autodetectable=enemySAMdetectBool})
ScenEdit_AddUnit({type='Facility', side=OPFORsideName, dbid=GciRadar2.dbid, unitname=GciRadar2.name, latitude=GciRadar2.latitude, longitude=GciRadar2.longitude, autodetectable=enemySAMdetectBool})
ScenEdit_AddUnit({type='Facility', side=OPFORsideName, dbid=GciRadar3.dbid, unitname=GciRadar3.name, latitude=GciRadar3.latitude, longitude=GciRadar3.longitude, autodetectable=enemySAMdetectBool})
ScenEdit_AddUnit({type='Facility', side=OPFORsideName, dbid=GciRadar4.dbid, unitname=GciRadar4.name, latitude=GciRadar4.latitude, longitude=GciRadar4.longitude, autodetectable=enemySAMdetectBool})
ScenEdit_AddUnit({type='Facility', side=OPFORsideName, dbid=GciRadar5.dbid, unitname=GciRadar5.name, latitude=GciRadar5.latitude, longitude=GciRadar5.longitude, autodetectable=enemySAMdetectBool})
ScenEdit_AddUnit({type='Facility', side=OPFORsideName, dbid=GciRadar6.dbid, unitname=GciRadar6.name, latitude=GciRadar6.latitude, longitude=GciRadar6.longitude, autodetectable=enemySAMdetectBool})

ScenEdit_SetEMCON('Unit', GciRadar1.name, 'Radar=Active')
ScenEdit_SetEMCON('Unit', GciRadar2.name, 'Radar=Active')
ScenEdit_SetEMCON('Unit', GciRadar3.name, 'Radar=Active')
ScenEdit_SetEMCON('Unit', GciRadar4.name, 'Radar=Active')
ScenEdit_SetEMCON('Unit', GciRadar5.name, 'Radar=Active')
ScenEdit_SetEMCON('Unit', GciRadar6.name, 'Radar=Active')

math.randomseed(os.time())

--***Figure out the battle's location, direction, and range
if TargetArea == 0 then
	--Change lat and lon below to scenario loc.
	ScenEdit_AddReferencePoint({side=PlayerSideName, name="Route Package 1", lat=17.417, lon=106.432, highlighted=true, locked = true})
	ScenEdit_AddReferencePoint({side=OPFORsideName, name="Centrepoint", lat=17.418, lon=106.433, highlighted=false})
	
	--Route Pack 1 is a short-range battle staged from Da Nang or Ubon
	playerRadial = math.random(130,215)
	StartDistance = 240
	
elseif TargetArea == 1 then 
	--Change lat and lon below to scenario loc.
	ScenEdit_AddReferencePoint({side=PlayerSideName, name="Route Package 5", lat=21.241, lon=102.800, highlighted=true, locked = true})
	ScenEdit_AddReferencePoint({side=OPFORsideName, name="Centrepoint", lat=21.242, lon=102.801, highlighted=false})
	
	--Route Pack 5 is a long-range battle staged from Udorn or Ubon
	playerRadial = math.random(167,190)
	StartDistance = 440
	
elseif TargetArea == 2 then 
	--Change lat and lon below to scenario loc.
	ScenEdit_AddReferencePoint({side=PlayerSideName, name="Route Package 6A", lat=21.000, lon=105.600, highlighted=true, locked = true})
	ScenEdit_AddReferencePoint({side=OPFORsideName, name="Centrepoint", lat=21.001, lon=105.601, highlighted=false})
	
	--Route Pack 6A is a very long-range battle staged from Udorn or Ubon
	playerRadial = math.random(188,216)
	StartDistance = 500
	
else
	--Change lat and lon below to scenario loc.
	ScenEdit_AddReferencePoint({side=PlayerSideName, name="Target Area Not Specified", lat=17.417, lon=106.432, highlighted=true, locked = true})
	ScenEdit_AddReferencePoint({side=OPFORsideName, name="Centrepoint", lat=17.418, lon=106.433, highlighted=false})
	
	playerRadial = math.random(130,215)
	StartDistance = 240
end

centrePoint = ScenEdit_GetReferencePoint({side=OPFORsideName,name='Centrepoint'}) --tied to a reference point so it's easy to move wherever you like


splitDistance = StartDistance / 2
enemyRadial = (playerRadial + 180)%360

playerStartPosition = World_GetPointFromBearing({
	latitude=centrePoint.latitude,
	longitude=centrePoint.longitude,
	bearing=playerRadial,
	distance=splitDistance})
	
enemyStartPosition = World_GetPointFromBearing({
	latitude=centrePoint.latitude,
	longitude=centrePoint.longitude,
	bearing=enemyRadial,
	distance=splitDistance/8})

StrikeAircraft = ReturnClassAndLoadout(StrikeAircraftClassAndLoadout,'_')
EscortAircraft = ReturnClassAndLoadout(EscortAircraftClassAndLoadout,'_')
SupportAircraft = ReturnClassAndLoadout(SupportAircraftClassAndLoadout, '_')
StandoffAircraft = ReturnClassAndLoadout(StandoffAircraftClassAndLoadout, '_')
ReconAircraft = ReturnClassAndLoadout(ReconAircraftClassAndLoadout, '_')

enemyAircraft = ReturnClassAndLoadout(EnemyAircraftClassAndLoadout,'_')

playerFlightCallsign = {}
playerEscortFlightCallsign = {}
playerSupportFlightCallsign = {}
playerStandoffFlightCallsign = {}

enemyFlightCallsign = enemyCallsign.." Flight"

--Only playerFlightCallsign actually has 6 entries 
for i = 1, 6 do
	playerFlightCallsign[i] = playerCallsign[i].." Flight"
	
	if i < 5 then
		playerEscortFlightCallsign[i] = playerEscortCallsign[i].." Flight"
	end
	if i < 4 then
		playerSupportFlightCallsign[i] = playerSupportCallsign[i].." Flight"
	end
	if i < 3 then
		playerStandoffFlightCallsign[i] = playerStandoffCallsign[i].." Flight"
	end	
end

--*** Add Strike Package Flights
for i = 1, StrikeAircraftQuantity do
	strikeLongOffset = (i-2)*0.01 
	AddFingerFour(
		playerCallsign[i],
		PlayerSideName,
		StrikeAircraft.dbid,
		StrikeAircraft.loadout,
		playerStartPosition.latitude,
		playerStartPosition.longitude + strikeLongOffset,
		enemyRadial,
		StartAltitude,
		BLUFORProficiency,
		playerFlightCallsign[i]
	)
end

--*** Add Escort Flights
if EscortAircraftQuantity > 0 then 

	for j = 1, EscortAircraftQuantity do 
		escortLatOffset = ((-1)^(j+1))*0.02
		escortLonOffset = escortLatOffset
	
		if j > 2 then
			escortLonOffset = -escortLonOffset
		end
	
		AddFingerFour(
			playerEscortCallsign[j],
			PlayerSideName,
			EscortAircraft.dbid,
			EscortAircraft.loadout,
			playerStartPosition.latitude + escortLatOffset,
			playerStartPosition.longitude + escortLonOffset,
			enemyRadial,
			StartAltitude,
			BLUFORProficiency,
			playerEscortFlightCallsign[j]
		)
	end
end	

--*** Add Support Flights with PREDETERMNED sizes	
if SupportAircraft.dbid ~= "0" then

	--2 flights of 2 Shrike-armed Wild Weasels
	if SupportAircraft.loadout == supportOption1 then
		
		for k = 1, 2 do
		
			supportLonOffset = 0.02*(k-1) 
	
			AddMultipleAircraft(
				2,
				playerSupportCallsign[k],
				PlayerSideName,
				SupportAircraft.dbid,
				SupportAircraft.loadout,
				playerStartPosition.latitude + .03,
				playerStartPosition.longitude + supportLonOffset,
				enemyRadial,
				StartAltitude,
				BLUFORProficiency,
				playerSupportFlightCallsign[k]
			)
		end	
	

	--2 flights of 4 CBU-armed F-105Ds or Fs
	elseif SupportAircraft.loadout == supportOption2  then
		
		for k = 1, 2 do
		
			supportLonOffset = 0.02*(k-1) 
	
			AddFingerFour(
				playerSupportCallsign[k],
				PlayerSideName,
				SupportAircraft.dbid,
				SupportAircraft.loadout,
				playerStartPosition.latitude + .03,
				playerStartPosition.longitude + supportLonOffset,
				enemyRadial,
				StartAltitude,
				BLUFORProficiency,
				playerSupportFlightCallsign[k]
			)
		end
	
	--Combo of Shrike-armed and CBU armed F-105s 
	elseif SupportAircraft.loadout == supportOption3 then
		
			supportLonOffset = 0.0 
	
			AddMultipleAircraft(
				2,
				playerSupportCallsign[1],
				PlayerSideName,
				SupportAircraft.dbid,
				shrikeLoadout,
				playerStartPosition.latitude + .03,
				playerStartPosition.longitude + supportLonOffset,
				enemyRadial,
				StartAltitude,
				BLUFORProficiency,
				playerSupportFlightCallsign[1]
			)
			
			supportLonOffset = 0.02 
			
			AddFingerFour(
				playerSupportCallsign[2],
				PlayerSideName,
				F105Ddbid,
				cbuLoadout,
				playerStartPosition.latitude + .03,
				playerStartPosition.longitude + supportLonOffset,
				enemyRadial,
				StartAltitude,
				BLUFORProficiency,
				playerSupportFlightCallsign[2]
			)
	
	--This choice is intended for a single jammer, to use special callsign 
	else 
		AddMultipleAircraft(
			1,
			playerSupportCallsign[3],
			PlayerSideName,
			SupportAircraft.dbid,
			SupportAircraft.loadout,
			playerStartPosition.latitude - .03,
			playerStartPosition.longitude,
			enemyRadial,
			StartAltitude,
			BLUFORProficiency,
			playerSupportFlightCallsign[3]
		)			
	end

end	

--*** Add Standoff Flight with PREDETERMNED sizes
if StandoffAircraft.dbid ~= "0" then

	-- Either a single jammer or single AEW
	if (StandoffAircraft.loadout == standoffOption1) or (StandoffAircraft.loadout == standoffOption2) then
		StandoffAircraftQuantity = 1
		playerStandoffCallsignB = playerStandoffCallsign[1]
		playerStandoffFlightCallsignB = playerStandoffFlightCallsign[1]
		
	--Meant for two tankers, using special callsign	
	else 
		StandoffAircraftQuantity = 2
		playerStandoffCallsignB = playerStandoffCallsign[2]
		playerStandoffFlightCallsignB = playerStandoffFlightCallsign[2]
	end


	AddMultipleAircraft(
		StandoffAircraftQuantity,
		playerStandoffCallsignB,
		PlayerSideName,
		StandoffAircraft.dbid,
		StandoffAircraft.loadout,
		playerStartPosition.latitude - .05,
		playerStartPosition.longitude,
		enemyRadial,
		StartAltitude,
		BLUFORProficiency,
		playerStandoffFlightCallsignB
	)

end

--Add Recon Aircraft to a base
if ReconAircraft.dbid ~= 0 then
	--First handel the Udorn-based A/C
	if ReconAircraft.dbid == RF101CDbid or ReconAircraft.dbid == RF4CDbid or ReconAircraft.dbid == RB66BDbid or ReconAircraft.dbid == U2CDbid then   
		reconAirfield = PlayerAirfield1.guid 
		
		--Special hard-coded U-2 Callsign
		if ReconAircraft.dbid == U2CDbid then
			playerReconCallsign = playerReconCallsignSpecial1
		end	
	
	--Next handel the Da Nang-based A/C
	elseif ReconAircraft.dbid == RF4BDbid or ReconAircraft.dbid == F100FDbid or ReconAircraft.dbid == O2ADbid then 
		reconAirfield = PlayerAirfield3.guid
		
		--Special hard-coded F-100F Callsign
		if ReconAircraft.dbid == F100FDbid then
			playerReconCallsign = playerReconCallsignSpecial2
		end
		
		--Special hard-coded O-2A Callsign
		if ReconAircraft.dbid == O2ADbid then
			playerReconCallsign = playerReconCallsignSpecial3
		end
		
	else
		reconAirfield = PlayerAirfield2.guid 
		ScenEdit_SpecialMessage (PlayerSideName, "ReconAircraft.dbid == "..ReconAircraft.dbid)
	end
	
	
	ScenEdit_AddUnit({type='Aircraft',side=PlayerSideName,dbid=ReconAircraft.dbid,name=playerReconCallsign..' #'..'1',loadoutid=ReconAircraft.loadout,base=reconAirfield,altitude=0,heading = 0,proficiency=BLUFORProficiency})
	ScenEdit_AddUnit({type='Aircraft',side=PlayerSideName,dbid=ReconAircraft.dbid,name=playerReconCallsign..' #'..'2',loadoutid=ReconAircraft.loadout,base=reconAirfield,altitude=0,heading = 0,proficiency=BLUFORProficiency})
end

--enemyAircraftList = AddMultipleAircraft(
	--EnemyAircraftQuantity,
	--enemyCallsign,
	--OPFORsideName,
	--enemyAircraft.dbid,
	--enemyAircraft.loadout,
	--enemyStartPosition.latitude,
	--enemyStartPosition.longitude,
	--playerRadial,
	--EnemyAltitude,
	--OPFORProficiency,
	--enemyFlightCallsign
--)

--*** Add Enemy Flights
enemyAircraftList = {}
if EnemyAircraftQuantity > 0 then 

	for j = 1, EnemyAircraftQuantity do 
		local enemyLatOffset = ((-1)^(j+1))*0.02
		local enemyLonOffset = enemyLatOffset
	
		enemyAircraftList[j] = AddFingerFour(
			enemyCallsign..j,
			OPFORsideName,
			enemyAircraft.dbid,
			enemyAircraft.loadout,
			enemyStartPosition.latitude + enemyLatOffset,
			enemyStartPosition.longitude + enemyLonOffset,
			playerRadial,
			EnemyAltitude,
			OPFORProficiency,
			enemyFlightCallsign..j
		)
	end
end

--***AddGroundUnits(quantity, callsign, dbid, latitude, longitude, divisorMod, isAutoDetected)
--***Target First
AddGroundUnits(
	EnemyTargetQuantity,
	'Target',
	EnemyTargetType,
	centrePoint.latitude,
	centrePoint.longitude,
	3,
	enemyTargetDetectBool
)

--New interdiction targets
AddGroundUnits(
	EnemyMobileQuantity,
	'Mobile',
	EnemyMobileType,
	centrePoint.latitude,
	centrePoint.longitude,
	3,
	false
)

AddGroundUnits(
	EnemySHORADQuantity,
	'SHORAD',
	EnemySHORADType,
	centrePoint.latitude,
	centrePoint.longitude,
	3,
	false
)

AddGroundUnits(
	EnemyMidRangeQuantity,
	'Mid Range',
	EnemyMidRangeType,
	centrePoint.latitude,
	centrePoint.longitude,
	3,
	false
)

customLat = centrePoint.latitude - 0.1 
customLong = centrePoint.longitude - 0.1


AddGroundUnits(
	EnemyLongRangeQuantity,
	'Long Range',
	EnemyLongRangeType,
	customLat,
	customLong,
	1.5,
	enemySAMdetectBool
)


--***the weather values below are just examples, temperature could probably do with some adjustment 
-- Need to keep in mind that this in now monsoon season in the tropics...
weatherTable = {
	{key=0, rainfall =0, undercloud=0, seastate =0, temperature=25},
	{key=1, rainfall =0, undercloud=0.1, seastate =1, temperature=24},
	{key=2, rainfall =0, undercloud=0.2, seastate =2, temperature=23},
	{key=3, rainfall =0, undercloud=0.3, seastate =3, temperature=22},
	{key=4, rainfall =0, undercloud=0.4, seastate =4, temperature=21},
	{key=5, rainfall =10, undercloud=0.5, seastate =5, temperature=20},
	{key=6, rainfall =25, undercloud=0.6, seastate =6, temperature=19},
	{key=7, rainfall =40, undercloud=0.7, seastate =7, temperature=18},
	{key=8, rainfall =55, undercloud=0.8, seastate =8, temperature=17},
	{key=9, rainfall =70, undercloud=0.9, seastate =9, temperature=16},
	{key=10, rainfall =100, undercloud=1, seastate =9, temperature=15},
}

for k,v in ipairs (weatherTable) do
	if v.key == Weather then
		ScenEdit_SetWeather(v.temperature, v.rainfall, v.undercloud, v.seastate)
    end
end

--***************************--
 
 
--********* SETUP MISSIONS *********--

--***29.167nm is a 5 minute stretch at 350kt; this will add one point in front and behind the Red aircraft so they start in the middle of their patrol zone
missionPatrolPoints = {
	World_GetPointFromBearing({latitude=enemyStartPosition.latitude,longitude=enemyStartPosition.longitude,distance=29.167/2,bearing=playerRadial}),
	World_GetPointFromBearing({latitude=enemyStartPosition.latitude,longitude=enemyStartPosition.longitude,distance=29.167/2,bearing=enemyRadial}),
	World_GetPointFromBearing({latitude=enemyStartPosition.latitude,longitude=enemyStartPosition.longitude,distance=29.167/2,bearing=(enemyRadial/2)}),
}

missionReferencePoints={}

for k,v in ipairs (missionPatrolPoints) do
	local referencePoint = ScenEdit_AddReferencePoint({side=OPFORsideName,name='Ref '..k,latitude=v.latitude,longitude=v.longitude})
	table.insert(missionReferencePoints,referencePoint.guid)
end

local mission = ScenEdit_AddMission (OPFORsideName, 'OPFOR Mission', 'Patrol', {type='AAW',zone=missionReferencePoints})

for j = 1, EnemyAircraftQuantity do

	for k,v in ipairs (enemyAircraftList[j]) do
		ScenEdit_AssignUnitToMission(v.guid,mission.guid)
	end

end

ScenEdit_SetMission(OPFORsideName, 'OPFOR Mission', {FlightsToInvestigate = "All"}) --Makes AI a little more effective to attack all at once
ScenEdit_SetDoctrine({mission=mission.name,side=mission.side},{weapon_control_status_air=0})
ScenEdit_SetEMCON("Mission",mission.name, 'Radar=Passive')

--***************************--


--********* SETUP TRIGGERS and EVENTS *********--



--***************************--