--***Yankee Station 1967 Version 3.0
--********* DATA ENTRY SECTION *********--

--***Name Sides
PlayerSideName = "USN"
OPFORsideName = "VPAF" 

--***Flight Names
playerCallsign = {}
playerCallsign[1] = 'Grumpy'
playerCallsign[2] = 'Bashful'
playerCallsign[3] = 'Sneezy'
playerCallsign[4] = 'Doc'
--playerCallsign[5] = 'Happy'
--playerCallsign[6] = 'Sleepy'

playerEscortCallsign = {} 
playerEscortCallsign[1] = 'Cowboy'
playerEscortCallsign[2] = 'Gunslinger'
playerEscortCallsign[3] = 'Sheriff'
playerEscortCallsign[4] = 'Outlaw'

playerSupportCallsign = {}
playerSupportCallsign[1] = 'Uzi'
playerSupportCallsign[2] = 'Colt'
--playerSupportCallsign[3] = 'Spark'

playerStandoffCallsign = {}
playerStandoffCallsign[1] = 'Zapper'  --For ECM
playerStandoffCallsign[2] = 'Drip' --For Tankers

playerInterdictionCallsign = {}
playerInterdictionCallsign[1] = 'Dallas'
playerInterdictionCallsign[2] = 'Houston'

playerReconCallsign = 'Cheese'

enemyCallsign = 'Red'
enemyTargetCallsign = 'Grunt'
enemyMobileCallsign = 'VC'

--***Define Airfields
PlayerAirfield1= {name="Udorn RTAFB", latitude='N 17.23.11',  longitude='E 102.47.18',  heading= 297.0}
PlayerAirfield2= {name="Ubon RTAFB",  latitude='N 15.15.05' , longitude='E 104.52.13',  heading= 230.0}
PlayerAirfield3= {name="Da Nang AB",  latitude='N 16.02.38' , longitude='E 108.11.58',  heading= 350.0}

OPFORAirfield1= {name="Phuc Yen AB",  latitude='N 21.13.16',  longitude='E 105.48.26',  heading= 290.0}
OPFORAirfield2= {name="Kep AB",      latitude='N 21.23.23',   longitude='E 106.15.09',  heading= 250.0 }
OPFORAirfield3= {name="Hoa Lac AB",  latitude='N 21.02.17',   longitude='E 105.29.24',  heading= 90.0 }

--***Define OPFOR Radars (Tall King 1802, Bar Lock 1801, Knife Rest 1809, Spoon Rest 1800)
GciRadar1= {name = 'GCI Radar 1', latitude = 21.6858379435911, longitude = 104.141244806841, dbid = 1802}  
GciRadar2= {name = 'GCI Radar 2', latitude = 18.631474, longitude = 105.734614, dbid = 1801} 	
GciRadar3= {name = 'GCI Radar 3', latitude = 'N 21.13.10', longitude = 'E 105.48.26', dbid = 1801} 
GciRadar4= {name = 'GCI Radar 4', latitude = 'N 21.19.07', longitude = 'E 105.29.26', dbid = 1800}  
GciRadar5= {name = 'GCI Radar 5', latitude = 'N 17.15.50', longitude = 'E 106.42.40', dbid = 1800} 	
GciRadar6= {name = 'GCI Radar 6', latitude = 'N 19.45.10', longitude = 'E 105.48.29', dbid = 1809}

--***Time, messages, etc.
ScenarioTimeDay = {Date="9.15.1967", Time="06.30.00"}
ScenarioTimeNight = {Date="9.16.1967", Time="17.30.00"}
ScenarioMessage1 = "Destroy your assigned targets, along with any additional targets of opportunity. Beware of hostile AAA, SAMs, and MiGs. Return your aircraft to the aircraft carrier upon mission completion."	

--***Special
A4CBuddyStoreDbid = "3317"
A6ABuddyStoreDbid = "3326"
KA3BDbid = "2140" 
 
RF4BDbid = "4055" 
RA3BDbid = "3042" 
--***************************--
	
--********* FUNCTION DEFINITIONS *********--
function ReturnClassAndLoadout(targetString,delimiter)
	local delimiter = string.find(targetString,delimiter)
	local extractedClass = string.sub(targetString,1,delimiter-1)
	local extractedLoadout = string.sub(targetString,delimiter+1,string.len(targetString))
	return {dbid = extractedClass,loadout = extractedLoadout}
end

function AddMultipleAircraft(quantity,callsign,side,dbid,loadout,latitude,longitude,heading,altitude,proficiency,groupName)
	local circle = World_GetCircleFromPoint({latitude=latitude,longitude=longitude,radius=0.5,numpoints = 72})
	local addedAircraftTable = {}
	if heading == nil then heading = 0 end
	if altitude== nil then altitude = 10000.0 end
	if quantity < 1 then quantity = 0 end
		for i = 1, quantity do
			if i > 1 then
				position = circle[i-1]
			else
				position = {latitude=latitude,longitude=longitude}
			end
			local unit = ScenEdit_AddUnit({type='Aircraft',side=side,dbid=dbid,name=callsign..' #'..i,loadoutid=loadout,latitude=position.latitude,longitude=position.longitude,heading=heading,altitude=altitude,proficiency=proficiency}); --default alt of 36kft; undefined altitude will throw an error; also seems to only recognise the integer and not the decimal so the underlying function may need tweaking
			unit.group=groupName
			table.insert(addedAircraftTable,unit)
		end	
	return addedAircraftTable
end

function AddFingerFour(callsign,side,dbid,loadout,latitudeIn,longitudeIn,heading,altitude,proficiency,groupName)
	--local circle = World_GetCircleFromPoint({latitude=latitude,longitude=longitude,radius=0.5,numpoints = 72})
	local addedAircraftTable = {}
	if heading == nil then heading = 0 end
	if altitude== nil then altitude = 10000.0 end
	--if quantity < 1 then quantity = 0 end
		for i = 1, 4 do
			if i == 1 then
				position = {latitude=latitudeIn,longitude=longitudeIn}
			elseif i == 2 then 
				position = {latitude=latitudeIn-0.002,longitude=longitudeIn-0.002}
			elseif i == 3 then
				position = {latitude=latitudeIn-0.002,longitude=longitudeIn+0.002}
			elseif i == 4 then	
				position = {latitude=latitudeIn-0.004,longitude=longitudeIn+0.004}
			else
				position = {latitude=latitudeIn,longitude=longitudeIn}
			end
			
			local unit = ScenEdit_AddUnit({type='Aircraft',side=side,dbid=dbid,name=callsign..' #'..i,loadoutid=loadout,latitude=position.latitude,longitude=position.longitude,heading=heading,altitude=altitude,proficiency=proficiency}); --default alt of 36kft; undefined altitude will throw an error; also seems to only recognise the integer and not the decimal so the underlying function may need tweaking
			unit.group=groupName
			table.insert(addedAircraftTable,unit)
		end	
	return addedAircraftTable
end

function AddTwoSections(callsign,side,dbid,loadout,latitudeIn,longitudeIn,heading,altitude,proficiency,groupName)
	--local circle = World_GetCircleFromPoint({latitude=latitude,longitude=longitude,radius=0.5,numpoints = 72})
	local addedAircraftTable = {}
	
	--For determining the tactical numbering
	local secNum = 0 
	local tacNum = 0
	
	if heading == nil then heading = 0 end
	if altitude== nil then altitude = 10000.0 end
	--if quantity < 1 then quantity = 0 end
		for i = 1, 4 do
			if i == 1 then
				position = {latitude=latitudeIn,longitude=longitudeIn}
				secNum = 1
				tacNum = 1
			elseif i == 2 then 
				position = {latitude=latitudeIn-0.002,longitude=longitudeIn-0.002}
				secNum = 1
				tacNum = 2
			elseif i == 3 then
				position = {latitude=latitudeIn-0.002,longitude=longitudeIn+0.002}
				secNum = 2
				tacNum = 1
			elseif i == 4 then	
				position = {latitude=latitudeIn-0.004,longitude=longitudeIn+0.004}
				secNum = 2
				tacNum = 2
			else
				position = {latitude=latitudeIn,longitude=longitudeIn}
			end
			
			local unit = ScenEdit_AddUnit({type='Aircraft',side=side,dbid=dbid,name=callsign..' '..secNum..tacNum,loadoutid=loadout,latitude=position.latitude,longitude=position.longitude,heading=heading,altitude=altitude,proficiency=proficiency}); --default alt of 36kft; undefined altitude will throw an error; also seems to only recognise the integer and not the decimal so the underlying function may need tweaking
			unit.group=groupName.." Section "..secNum 
			table.insert(addedAircraftTable,unit)
		end	
	return addedAircraftTable
end

function AddGroundUnits(quantity, callsign, dbid, latitude, longitude, divisorMod, isAutoDetected)
	--lat-lon is lower left corner of closest unit. Divisor will dictate how close, 1 will be ~ 35 mile. 2 will be 17 miles, 4 will be 7 miles. .5 will be 65 miles. .25 will be 90 miles
	--math.randomseed(os.time())
	latbasic = latitude
	lonbasic = longitude
	divisor = divisorMod --divisor changes spacing
	for i = 1,quantity do
		redo_count = 0
		::redo::
		local lat_var = (math.random(1,(10^14))/divisor)
		print(lat_var)
		local lon_var = (math.random(1,(10^14))/divisor)
		print(lon_var)
		DummyPoint=ScenEdit_AddReferencePoint({side=OPFORsideName, name="DummyPoint", latitude=latbasic, longitude=lonbasic, highlighted=false}) --This is for a compatibility fix for using Sting DMS format for Lat/Lon  
		v_lat = DummyPoint.latitude + (lat_var/(10^14))
		print("V.Lat is ".. v_lat)
		v_lon = DummyPoint.longitude + (lon_var/(10^14))
		print("V.Lon is ".. v_lon)
		ScenEdit_DeleteReferencePoint({side=OPFORsideName, name="DummyPoint"})
		elevation = World_GetElevation({latitude=v_lat, longitude=v_lon})
		if elevation < 1.0 then --Checks to see if the water is deep enough, adjust as you please
			redo_count = redo_count + 1
			if redo_count > 75 then
				if DebugMode == 1 then
					ScenEdit_AddReferencePoint({side=PlayerSideName, name="Unit "..callsign..i.." underwater 75x", lat=v_lat, lon=v_lon, highlighted=true})
					ScenEdit_AddReferencePoint({side=OPFORsideName, name="Unit "..callsign..i.." underwater 75x", lat=v_lat, lon=v_lon, highlighted=true})
				end
				break --this cuts the loop if there are no suitable positions found after 50 tries, prevents infinite loop/game freeze
			else
				goto redo --retries the placement if the water is too shallow
			end
		end
	DBIDUnit = dbid
	local new_merch = ScenEdit_AddUnit({side=OPFORsideName, type='Facility',name=callsign ..i, dbid=DBIDUnit, latitude=v_lat, longitude=v_lon, autodetectable=isAutoDetected})
	if DebugMode == 1 then
		ScenEdit_AddReferencePoint({side=PlayerSideName, name="Unit "..callsign..i.." created", lat=v_lat, lon=v_lon, highlighted=true})
	end	
	--ScenEdit_SetEMCON('Unit', new_merch.guid, 'Inherit;'..EnemyEMCON)
	end

end


function AddSeaUnits(quantity, callsign, dbid, latitude, longitude, divisorMod)
	--lat-lon is lower left corner of closest unit. Divisor will dictate how close, 1 will be ~ 35 mile. 2 will be 17 miles, 4 will be 7 miles. .5 will be 65 miles. .25 will be 90 miles
	--math.randomseed(os.time())
	latbasic = latitude
	lonbasic = longitude
	divisor = divisorMod --divisor changes spacing
	for i = 1,quantity do
		redo_count = 0
		::redo::
		local lat_var = (math.random(1,(10^14))/divisor)
		print(lat_var)
		local lon_var = (math.random(1,(10^14))/divisor)
		print(lon_var)
		v_lat = latbasic + (lat_var/(10^14)) --change 27 and 32 to your specified minimum and maximum latitude values; it's important that the first number is smaller than the second.
		print("V.Lat is ".. v_lat)
		v_lon = lonbasic + (lon_var/(10^14)) --change 119 and 127 to your specified minimum and maximum longitude values; it's important that the first number is smaller than the second.
		print("V.Lon is ".. v_lon)
		elevation = World_GetElevation({latitude=v_lat, longitude=v_lon})
		if elevation > 0.0 then --Reverse of adding a land unit
			redo_count = redo_count + 1
			if redo_count > 50 then
				if DebugMode == 1 then
					ScenEdit_AddReferencePoint({side=PlayerSideName, name="Ship Unit "..callsign..i.." on land 50x", lat=v_lat, lon=v_lon, highlighted=true})
					ScenEdit_AddReferencePoint({side=OPFORsideName, name="Ship Unit "..callsign..i.." on land 50x", lat=v_lat, lon=v_lon, highlighted=true})
				end
				break --this cuts the loop if there are no suitable positions found after 50 tries, prevents infinite loop/game freeze
			else
				goto redo --retries the placement if the water is too shallow
			end
		end
	DBIDUnit = dbid
	local new_merch = ScenEdit_AddUnit({side=OPFORsideName, type='Ship',name=callsign ..i, dbid=DBIDUnit, latitude=v_lat, longitude=v_lon}) --These are ships
	if DebugMode == 1 then
		ScenEdit_AddReferencePoint({side=PlayerSideName, name="Sea Unit "..callsign..i.." created", lat=v_lat, lon=v_lon, highlighted=true})
	end	
	--ScenEdit_SetEMCON('Unit', new_merch.guid, 'Inherit;'..EnemyEMCON)
	end

end
--***************************--	


--********* SCENARIO SETUP *********--

--***Side definitions

if DebugModeOPFOR == 1 then --play as OPFOR for debugging
	ScenEdit_AddSide({Name=OPFORsideName})
	ScenEdit_AddSide({Name=PlayerSideName})
else	--normal play
	ScenEdit_AddSide({Name=PlayerSideName})
	ScenEdit_AddSide({Name=OPFORsideName})
end

ScenEdit_SetSidePosture(PlayerSideName, OPFORsideName, "H")
ScenEdit_SetSidePosture(OPFORsideName, PlayerSideName, "H")

--***Convert altitudes to feet
StartAltitude = StartAltitude.." FT"
EnemyAltitude = EnemyAltitude.." FT"


--***Set a flag to determine if enemy SAMS and radar are autodetected
if EnemySAMdetect == 0 then
	enemySAMdetectBool = false	
elseif EnemySAMdetect == 1 then 	
	enemySAMdetectBool = true
else	
	enemySAMdetectBool = true
	ScenEdit_AddReferencePoint({side=PlayerSideName, name="Error with SAM visibility settings!", lat=17.417, lon=106.432, highlighted=true})
end

--***Set a flag to determine if enemy targets are autodetected
if EnemyTargetDetect == 0 then
	enemyTargetDetectBool = false	
elseif EnemyTargetDetect == 1 then 	
	enemyTargetDetectBool = true
else	
	enemyTargetDetectBool = true
	ScenEdit_AddReferencePoint({side=PlayerSideName, name="Error with Target visibility settings!", lat=17.417, lon=106.432, highlighted=true})
end

--***Enemy ROE is WEAPONS_FREE, Player ROE is WEAPONS_TIGHT (a historical frustration!)  
ScenEdit_SetDoctrine({side=OPFORsideName},{weapon_control_status_air=0})
ScenEdit_SetDoctrine({side=PlayerSideName},{weapon_control_status_air=1})

--***USN needs to look for MiGs and start standoff jamming from the start  
ScenEdit_SetEMCON('Side',PlayerSideName,'Radar=Active;Sonar=Passive;OECM=Active')
--ScenEdit_SetEMCON('Side',OPFORsideName,'Radar=Active;Sonar=Passive;OECM=Passive')

--***Set time and play starting messages, etc.
if TimeDayNight == 1 then 
	ScenEdit_SetTime(ScenarioTimeNight)
elseif TimeDayNight == 0 then 
	ScenEdit_SetTime(ScenarioTimeDay)
else
	ScenEdit_SpecialMessage (PlayerSideName, "Error setting scenario time")
end
ScenEdit_SpecialMessage (PlayerSideName, ScenarioMessage1)

--***Add all static, non-random units

--***Reference Points
ScenEdit_AddReferencePoint({side=PlayerSideName, name="Yankee Station", lat='N 17.30.00', lon='E 108.30.00', highlighted=true, locked=true})
yankeeStation = ScenEdit_GetReferencePoint({side=PlayerSideName, name='Yankee Station'})

--***Ships
playerCVA = ScenEdit_AddUnit({side=PlayerSideName, type='Ship', name=' ', dbid=CVABase, latitude=yankeeStation.latitude-0.25, longitude=yankeeStation.longitude-0.25, heading=45.0, manualSpeed = 25.0, throttle = 'Full', course = {{latitude=yankeeStation.latitude+0.25, longitude=yankeeStation.longitude+0.25, description = "WP"}} })
ScenEdit_SetUnit({
	guid=playerCVA.guid,
	newname=playerCVA.classname
})
ScenEdit_SetEMCON('Unit',playerCVA.name,'Radar=Active;Sonar=Passive;OECM=Passive')

--***Airfields
--PlayerAirfield1=ScenEdit_AddUnit({side=PlayerSideName, type='Facility', name=PlayerAirfield1.name, dbid=1568, latitude=PlayerAirfield1.latitude, longitude=PlayerAirfield1.longitude, heading=PlayerAirfield1.heading})
--PlayerAirfield2=ScenEdit_AddUnit({side=PlayerSideName, type='Facility', name=PlayerAirfield2.name, dbid=1568, latitude=PlayerAirfield2.latitude, longitude=PlayerAirfield2.longitude, heading=PlayerAirfield2.heading})
PlayerAirfield3=ScenEdit_AddUnit({side=PlayerSideName, type='Facility', name=PlayerAirfield3.name, dbid=1568, latitude=PlayerAirfield3.latitude, longitude=PlayerAirfield3.longitude, heading=PlayerAirfield3.heading})

ScenEdit_AddUnit({side=OPFORsideName, type='Facility', name=OPFORAirfield1.name, dbid=1568, latitude=OPFORAirfield1.latitude, longitude=OPFORAirfield1.longitude, heading=OPFORAirfield1.heading})
ScenEdit_AddUnit({side=OPFORsideName, type='Facility', name=OPFORAirfield2.name, dbid=1568, latitude=OPFORAirfield2.latitude, longitude=OPFORAirfield2.longitude, heading=OPFORAirfield2.heading})
ScenEdit_AddUnit({side=OPFORsideName, type='Facility', name=OPFORAirfield3.name, dbid=1568, latitude=OPFORAirfield3.latitude, longitude=OPFORAirfield3.longitude, heading=OPFORAirfield3.heading})

--***Radar 
ScenEdit_AddUnit({type='Facility', side=OPFORsideName, dbid=GciRadar1.dbid, unitname=GciRadar1.name, latitude=GciRadar1.latitude, longitude=GciRadar1.longitude, autodetectable=enemySAMdetectBool})
ScenEdit_AddUnit({type='Facility', side=OPFORsideName, dbid=GciRadar2.dbid, unitname=GciRadar2.name, latitude=GciRadar2.latitude, longitude=GciRadar2.longitude, autodetectable=enemySAMdetectBool})
ScenEdit_AddUnit({type='Facility', side=OPFORsideName, dbid=GciRadar3.dbid, unitname=GciRadar3.name, latitude=GciRadar3.latitude, longitude=GciRadar3.longitude, autodetectable=enemySAMdetectBool})
ScenEdit_AddUnit({type='Facility', side=OPFORsideName, dbid=GciRadar4.dbid, unitname=GciRadar4.name, latitude=GciRadar4.latitude, longitude=GciRadar4.longitude, autodetectable=enemySAMdetectBool})
ScenEdit_AddUnit({type='Facility', side=OPFORsideName, dbid=GciRadar5.dbid, unitname=GciRadar5.name, latitude=GciRadar5.latitude, longitude=GciRadar5.longitude, autodetectable=enemySAMdetectBool})
ScenEdit_AddUnit({type='Facility', side=OPFORsideName, dbid=GciRadar6.dbid, unitname=GciRadar6.name, latitude=GciRadar6.latitude, longitude=GciRadar6.longitude, autodetectable=enemySAMdetectBool})

ScenEdit_SetEMCON('Unit', GciRadar1.name, 'Radar=Active')
ScenEdit_SetEMCON('Unit', GciRadar2.name, 'Radar=Active')
ScenEdit_SetEMCON('Unit', GciRadar3.name, 'Radar=Active')
ScenEdit_SetEMCON('Unit', GciRadar4.name, 'Radar=Active')
ScenEdit_SetEMCON('Unit', GciRadar5.name, 'Radar=Active')
ScenEdit_SetEMCON('Unit', GciRadar6.name, 'Radar=Active')

math.randomseed(os.time())


--***Figure out the battle's location, direction, and range
if TargetArea == 0 then
	--Change lat and lon below to scenario loc.
	ScenEdit_AddReferencePoint({side=PlayerSideName, name="Route Package 2", lat='N 18.18.00', lon='E 105.51.45', highlighted=true, locked=true})
	ScenEdit_AddReferencePoint({side=OPFORsideName, name="Centrepoint", lat='N 18.17.00', lon='E 105.50.45', highlighted=false})
	
	--TO DO: Edit this
	--playerRadial = math.random(130,215)
	--StartDistance = 240
	
elseif TargetArea == 1 then 
	--Change lat and lon below to scenario loc.
	ScenEdit_AddReferencePoint({side=PlayerSideName, name="Route Package 3", lat='N 18.38.30', lon='E 105.33.30', highlighted=true, locked=true})
	ScenEdit_AddReferencePoint({side=OPFORsideName, name="Centrepoint", lat='N 18.37.30', lon='E 105.32.30', highlighted=false})
	
	--TO DO: Edit this
	--playerRadial = math.random(167,190)
	--StartDistance = 440
	
elseif TargetArea == 2 then 
	--Change lat and lon below to scenario loc.
	ScenEdit_AddReferencePoint({side=PlayerSideName, name="Route Package 4", lat='N 19.46.30', lon='E 105.39.30', highlighted=true, locked=true})
	ScenEdit_AddReferencePoint({side=OPFORsideName, name="Centrepoint", lat='N 19.45.30', lon='E 105.38.30', highlighted=false})
	
	--TO DO: Edit this
	--playerRadial = math.random(188,216)
	--StartDistance = 500

elseif TargetArea == 3 then 
	--Change lat and lon below to scenario loc.
	ScenEdit_AddReferencePoint({side=PlayerSideName, name="Route Package 6B", lat='N 20.37.30', lon='E 106.33.00', highlighted=true, locked=true})
	ScenEdit_AddReferencePoint({side=OPFORsideName, name="Centrepoint", lat='N 20.36.30', lon='E 106.32.00', highlighted=false})
	
	--TO DO: Edit this
	--playerRadial = math.random(188,216)
	--StartDistance = 500
	
else
	--Change lat and lon below to scenario loc.
	ScenEdit_AddReferencePoint({side=PlayerSideName, name="Target Area Not Specified", lat=17.417, lon=106.432, highlighted=true, locked = true})
	ScenEdit_AddReferencePoint({side=OPFORsideName, name="Centrepoint", lat=17.418, lon=106.433, highlighted=false})
	
	--TO DO: Edit this
	--playerRadial = math.random(130,215)
	--StartDistance = 240
end

centrePoint = ScenEdit_GetReferencePoint({side=OPFORsideName,name='Centrepoint'}) --tied to a reference point so it's easy to move wherever you like
 
--splitDistance = StartDistance / 2
--enemyRadial = (playerRadial + 180)%360

--Start with a constant heading to the NorthWest
enemyRadial = 315.0

--Enemy start with a constant heading to the south
playerRadial = 180.0

--Player will always start from Yankee station itself
playerStartPosition = {latitude=yankeeStation.latitude, longitude=yankeeStation.longitude}

--Enemy will start a little NW of the centerpoint	
enemyStartPosition = {latitude=centrePoint.latitude + 0.05, longitude=centrePoint.longitude - 0.05}

StrikeAircraft = ReturnClassAndLoadout(StrikeAircraftClassAndLoadout,'_')
EscortAircraft = ReturnClassAndLoadout(EscortAircraftClassAndLoadout,'_')
SupportAircraft = ReturnClassAndLoadout(SupportAircraftClassAndLoadout, '_')
InterdictionAircraft = ReturnClassAndLoadout(InterdictionAircraftClassAndLoadout, '_') 
StandoffAircraft = ReturnClassAndLoadout(StandoffAircraftClassAndLoadout, '_')
ReconAircraft = ReturnClassAndLoadout(ReconAircraftClassAndLoadout, '_')

enemyAircraft = ReturnClassAndLoadout(EnemyAircraftClassAndLoadout,'_')

playerFlightCallsign = {}
playerEscortFlightCallsign = {}
playerSupportFlightCallsign = {}
playerInterdictionFlightCallsign = {}
playerStandoffFlightCallsign = {}

enemyFlightCallsign = enemyCallsign.." Flight"

--Setup the Flight as opposed to individual callsigns
for i = 1, 4 do
	playerFlightCallsign[i] = playerCallsign[i].." Flight"
	playerEscortFlightCallsign[i] = playerEscortCallsign[i] --.." Flight"
	
	if i < 3 then
		playerSupportFlightCallsign[i] = playerSupportCallsign[i].." Flight"
		playerStandoffFlightCallsign[i] = playerStandoffCallsign[i].." Flight"  --May not be needed
		playerInterdictionFlightCallsign[i] = playerInterdictionCallsign[i].." Flight"
	end	
end

--*** Add Strike Package Flights
for i = 1, StrikeAircraftQuantity do
	strikeLongOffset = (i-2)*0.01 
	AddFingerFour(
		playerCallsign[i],
		PlayerSideName,
		StrikeAircraft.dbid,
		StrikeAircraft.loadout,
		playerStartPosition.latitude,
		playerStartPosition.longitude + strikeLongOffset,
		enemyRadial,
		StartAltitude,
		BLUFORProficiency,
		playerFlightCallsign[i]
	)
end

--*** Add Escort Flights
if EscortAircraftQuantity > 0 then 

	for j = 1, EscortAircraftQuantity do 
		escortLatOffset = ((-1)^(j+1))*0.02
		escortLonOffset = escortLatOffset
	
		if j > 2 then
			escortLonOffset = -escortLonOffset
		end
	
		AddTwoSections(
			playerEscortCallsign[j],
			PlayerSideName,
			EscortAircraft.dbid,
			EscortAircraft.loadout,
			playerStartPosition.latitude + escortLatOffset,
			playerStartPosition.longitude + escortLonOffset,
			enemyRadial,
			StartAltitude,
			BLUFORProficiency,
			playerEscortFlightCallsign[j]
		)
	end
end	

--*** Add Support Flights with PREDETERMNED 2-ship size	
if SupportAircraft.dbid ~= "0" then

	--2 flights of 2 Shrike-armed Iron Hand
	for k = 1, 2 do
		
		supportLonOffset = 0.02*(k-1) 
	
		AddMultipleAircraft(
			2,
			playerSupportCallsign[k],
			PlayerSideName,
			SupportAircraft.dbid,
			SupportAircraft.loadout,
			playerStartPosition.latitude + .03,
			playerStartPosition.longitude + supportLonOffset,
			enemyRadial,
			StartAltitude,
			BLUFORProficiency,
			playerSupportFlightCallsign[k]
		)
	end		
end	

--*** Add Interdiction Flights with PREDETERMNED 4-ship size	
if InterdictionAircraftQuantity ~= "0" then

	--flights of 4 for Interdiction
	for p = 1, InterdictionAircraftQuantity do
		
		interdictionLonOffset = (StrikeAircraftQuantity+p-2)*0.01 --continue the line from where the strike A/C left off 
	
		AddFingerFour(
			playerInterdictionCallsign[p],
			PlayerSideName,
			InterdictionAircraft.dbid,
			InterdictionAircraft.loadout,
			playerStartPosition.latitude,
			playerStartPosition.longitude + interdictionLonOffset,
			enemyRadial,
			StartAltitude,
			BLUFORProficiency,
			playerInterdictionFlightCallsign[p]
		)
	end		
end

--*** Add Standoff Aircraft, but avoid assigning to a Flight due to game issues with tanker flights
if StandoffAircraft.dbid ~= "0" then

	-- The buddy store A/C are a special case
	if (StandoffAircraft.dbid == A4CBuddyStoreDbid) or (StandoffAircraft.dbid == A6ABuddyStoreDbid) then
		
		--Either 4 A-4s or 2 A-6s
		if StandoffAircraft.dbid == A4CBuddyStoreDbid then 
			StandoffAircraftQuantity = 4
		elseif StandoffAircraft.dbid == A6ABuddyStoreDbid then
			StandoffAircraftQuantity = 2
		end
		
		--Add to the carrier
		for m = 1, StandoffAircraftQuantity do 
			ScenEdit_AddUnit({type='Aircraft',side=PlayerSideName,dbid=StandoffAircraft.dbid,name=playerStandoffCallsign[2]..' #'..m,loadoutid=StandoffAircraft.loadout,base=playerCVA.guid,altitude=0,heading = 0,proficiency=BLUFORProficiency})
		end
	
	--Special case to use the tanker callsign
	elseif StandoffAircraft.dbid == KA3BDbid then
		ScenEdit_AddUnit({type='Aircraft',side=PlayerSideName,dbid=StandoffAircraft.dbid,name=playerStandoffCallsign[2]..' #'..1,loadoutid=StandoffAircraft.loadout,latitude=playerStartPosition.latitude - .05,longitude=playerStartPosition.longitude,altitude=StartAltitude,heading = enemyRadial,proficiency=BLUFORProficiency})
	
	--Anything else airstarts with the ECM callsign
	else	
		ScenEdit_AddUnit({type='Aircraft',side=PlayerSideName,dbid=StandoffAircraft.dbid,name=playerStandoffCallsign[1]..' #'..1,loadoutid=StandoffAircraft.loadout,latitude=playerStartPosition.latitude - .05,longitude=playerStartPosition.longitude,altitude=StartAltitude,heading = enemyRadial,proficiency=BLUFORProficiency})
	end
end

--Add Recon Aircraft to a base
if ReconAircraft.dbid ~= 0 then

	--Handel the Da Nang-based A/C
	if ReconAircraft.dbid == RF4BDbid or ReconAircraft.dbid == RA3BDbid  then 
		reconAirfield = PlayerAirfield3.guid
		
	--Start everything else from the carrier	
	else
		reconAirfield = playerCVA.guid 
		
	end
	
	--Add two individual units
	ScenEdit_AddUnit({type='Aircraft',side=PlayerSideName,dbid=ReconAircraft.dbid,name=playerReconCallsign..' #'..'1',loadoutid=ReconAircraft.loadout,base=reconAirfield,altitude=0,heading = 0,proficiency=BLUFORProficiency})
	ScenEdit_AddUnit({type='Aircraft',side=PlayerSideName,dbid=ReconAircraft.dbid,name=playerReconCallsign..' #'..'2',loadoutid=ReconAircraft.loadout,base=reconAirfield,altitude=0,heading = 0,proficiency=BLUFORProficiency})
end

--*** Add Enemy Flights
enemyAircraftList = {}
if EnemyAircraftQuantity > 0 then 

	for j = 1, EnemyAircraftQuantity do 
		local enemyLatOffset = ((-1)^(j+1))*0.02
		local enemyLonOffset = enemyLatOffset
	
		enemyAircraftList[j] = AddFingerFour(
			enemyCallsign..j,
			OPFORsideName,
			enemyAircraft.dbid,
			enemyAircraft.loadout,
			enemyStartPosition.latitude + enemyLatOffset,
			enemyStartPosition.longitude + enemyLonOffset,
			playerRadial,
			EnemyAltitude,
			OPFORProficiency,
			enemyFlightCallsign..j
		)
	end
end

--***AddGroundUnits(quantity, callsign, dbid, latitude, longitude, divisorMod, isAutoDetected)
--***Target First
AddGroundUnits(
	EnemyTargetQuantity,
	'Target',
	EnemyTargetType,
	centrePoint.latitude,
	centrePoint.longitude,
	3,
	enemyTargetDetectBool
)

--New interdiction targets
AddGroundUnits(
	EnemyMobileQuantity,
	'Mobile',
	EnemyMobileType,
	centrePoint.latitude,
	centrePoint.longitude,
	3,
	false
)

----New sea targets
AddSeaUnits(
	EnemySeaQuantity,
	'Boat',
	EnemySeaType,
	centrePoint.latitude,  
	centrePoint.longitude + 0.167, --start the ships a little bit (about 10' of longitude) off the coast
	2,
	false
)

AddGroundUnits(
	EnemySHORADQuantity,
	'SHORAD',
	EnemySHORADType,
	centrePoint.latitude,
	centrePoint.longitude,
	3,
	false
)

AddGroundUnits(
	EnemyMidRangeQuantity,
	'Mid Range',
	EnemyMidRangeType,
	centrePoint.latitude,
	centrePoint.longitude,
	3,
	false
)

customLat = centrePoint.latitude - 0.1 
customLong = centrePoint.longitude - 0.1


AddGroundUnits(
	EnemyLongRangeQuantity,
	'Long Range',
	EnemyLongRangeType,
	customLat,
	customLong,
	1.5,
	enemySAMdetectBool
)


--***the weather values below are just examples, temperature could probably do with some adjustment 
-- Need to keep in mind that this in now monsoon season in the tropics...
weatherTable = {
	{key=0, rainfall =0, undercloud=0, seastate =0, temperature=25},
	{key=1, rainfall =0, undercloud=0.1, seastate =1, temperature=24},
	{key=2, rainfall =0, undercloud=0.2, seastate =2, temperature=23},
	{key=3, rainfall =0, undercloud=0.3, seastate =3, temperature=22},
	{key=4, rainfall =0, undercloud=0.4, seastate =4, temperature=21},
	{key=5, rainfall =10, undercloud=0.5, seastate =5, temperature=20},
	{key=6, rainfall =25, undercloud=0.6, seastate =6, temperature=19},
	{key=7, rainfall =40, undercloud=0.7, seastate =7, temperature=18},
	{key=8, rainfall =55, undercloud=0.8, seastate =8, temperature=17},
	{key=9, rainfall =70, undercloud=0.9, seastate =9, temperature=16},
	{key=10, rainfall =100, undercloud=1, seastate =9, temperature=15},
}

for k,v in ipairs (weatherTable) do
	if v.key == Weather then
		ScenEdit_SetWeather(v.temperature, v.rainfall, v.undercloud, v.seastate)
    end
end

--***************************--
 
 
--********* SETUP MISSIONS *********--

--***29.167nm is a 5 minute stretch at 350kt; this will add one point in front and behind the Red aircraft so they start in the middle of their patrol zone
missionPatrolPoints = {
	World_GetPointFromBearing({latitude=enemyStartPosition.latitude,longitude=enemyStartPosition.longitude,distance=29.167/2,bearing=135.0}),
	World_GetPointFromBearing({latitude=enemyStartPosition.latitude,longitude=enemyStartPosition.longitude,distance=29.167/2,bearing=315.0}),
	World_GetPointFromBearing({latitude=enemyStartPosition.latitude,longitude=enemyStartPosition.longitude,distance=29.167/2,bearing=(150.0)}),
}

missionReferencePoints={}

for k,v in ipairs (missionPatrolPoints) do
	local referencePoint = ScenEdit_AddReferencePoint({side=OPFORsideName,name='Ref '..k,latitude=v.latitude,longitude=v.longitude})
	table.insert(missionReferencePoints,referencePoint.guid)
end

local mission = ScenEdit_AddMission (OPFORsideName, 'OPFOR Mission', 'Patrol', {type='AAW',zone=missionReferencePoints})

for j = 1, EnemyAircraftQuantity do

	for k,v in ipairs (enemyAircraftList[j]) do
		ScenEdit_AssignUnitToMission(v.guid,mission.guid)
	end

end

ScenEdit_SetMission(OPFORsideName, 'OPFOR Mission', {FlightsToInvestigate = "All"}) --Makes AI a little more effective to attack all at once
ScenEdit_SetDoctrine({mission=mission.name,side=mission.side},{weapon_control_status_air=0})
ScenEdit_SetEMCON("Mission",mission.name, 'Radar=Passive')

--***************************--


--********* SETUP TRIGGERS and EVENTS *********--



--***************************--